#include <bits/stdc++.h>
using namespace std;
int n,m;
string mat;
int main(){
    cin>>n>>m;
    cin>>mat;
    vector<int> vrv(m,-1);
    vector<int> vrs(m,-1);
    queue<int> qv,qs;
    int pocetak=-1;
    for(int j=0;j<m;j++){
        if(mat[j]=='X'){
            qv.push(j);
            vrv[j]=0;
        }
        else if(mat[j]=='S'){
            pocetak=j;
            qs.push(j);
            vrs[j]=0;
        }
    }
    while(!qv.empty()){
        int poz=qv.front();
        qv.pop();
        int l=poz-1;
        if(l>=0 and mat[l]=='.' and vrv[l]==-1){
            vrv[l]=vrv[poz]+1;
            qv.push(l);
        }
        int d=poz+1;
        if(d<m and mat[d]=='.' and vrv[d]==-1){
            vrv[d]=vrv[poz]+1;
            qv.push(d);
        }
    }
    while(!qs.empty()){
        int poz=qs.front();
        qs.pop();
        int l=poz-1;
        if(l>=0 and mat[l]=='.' and vrs[l]==-1){
            int sledecevr=vrs[poz]+1;
            if(vrv[l]==-1 or vrv[l]>sledecevr){
                vrs[l]=sledecevr;
                qs.push(l);
            }
        }
        int d=poz+1;
        if(d<m and mat[d]=='.' and vrs[d]==-1){
            int sledecevr=vrs[poz]+1;
            if(vrv[d]==-1 or vrv[d]>sledecevr){
                vrs[d]=sledecevr;
                qs.push(d);
            }
        }
    }
    int res=0;
    for(int j=0;j<m;j++){
        if(vrs[j]!=-1 and (vrv[j]==-1 or vrs[j]<vrv[j])){
            res++;
        }
    }
    cout<<res<<endl;
    return 0;
}